searchData={"items":[{"type":"module","title":"ExOwm","doc":"ExOwm, OpenWeatherMap API Elixir client.\nThis module contains main public interface of the application.","ref":"ExOwm.html"},{"type":"function","title":"ExOwm.get_current_weather/2","doc":"Gets weather data of the given location with specified options.","ref":"ExOwm.html#get_current_weather/2"},{"type":"function","title":"Examples - ExOwm.get_current_weather/2","doc":"iex> ExOwm.get_current_weather([%{city: \"Warsaw\"}, %{city: \"London\", country_code: \"uk\"}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_current_weather/2-examples"},{"type":"function","title":"ExOwm.get_five_day_forecast/2","doc":"Gets 5 day forecast data of the given location with specified options.","ref":"ExOwm.html#get_five_day_forecast/2"},{"type":"function","title":"Examples - ExOwm.get_five_day_forecast/2","doc":"iex> ExOwm.get_five_day_forecast([%{city: \"Warsaw\"}, %{city: \"London\", country_code: \"uk\"}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_five_day_forecast/2-examples"},{"type":"function","title":"ExOwm.get_historical_weather/2","doc":"Gets historical weather data of the given location with specified options.\ndt should be within the last 5 days.","ref":"ExOwm.html#get_historical_weather/2"},{"type":"function","title":"Examples - ExOwm.get_historical_weather/2","doc":"iex> ExOwm.get_historical_weather([%{lat: 52.374031, lon: 4.88969, dt: 1615546800}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_historical_weather/2-examples"},{"type":"function","title":"ExOwm.get_hourly_forecast/2","doc":"Gets 4 day hourly forecast data of the given location with specified options.","ref":"ExOwm.html#get_hourly_forecast/2"},{"type":"function","title":"Examples - ExOwm.get_hourly_forecast/2","doc":"iex> ExOwm.get_hourly_forecast([%{city: \"Warsaw\"}, %{city: \"London\", country_code: \"uk\"}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_hourly_forecast/2-examples"},{"type":"function","title":"ExOwm.get_sixteen_day_forecast/2","doc":"Gets 1 to 16 days forecast data of the given location with specified options.","ref":"ExOwm.html#get_sixteen_day_forecast/2"},{"type":"function","title":"Examples - ExOwm.get_sixteen_day_forecast/2","doc":"iex> ExOwm.get_sixteen_day_forecast([%{city: \"Warsaw\"}, %{city: \"London\", country_code: \"uk\"}], units: :metric, lang: :pl, cnt: 16)","ref":"ExOwm.html#get_sixteen_day_forecast/2-examples"},{"type":"function","title":"ExOwm.get_weather/2","doc":"Gets weather data of the given location with specified options.","ref":"ExOwm.html#get_weather/2"},{"type":"function","title":"Examples - ExOwm.get_weather/2","doc":"iex> ExOwm.get_weather([%{lat: 52.374031, lon: 4.88969}], units: :metric, lang: :pl)","ref":"ExOwm.html#get_weather/2-examples"},{"type":"type","title":"ExOwm.option/0","doc":"Current weather data API call options corresponding to OWM APIs described in\nofficial docs: http://openweathermap.org/api\n\nThe output of the request can be specified according to below options.","ref":"ExOwm.html#t:option/0"},{"type":"type","title":"ExOwm.options/0","doc":"Keyword list of options.","ref":"ExOwm.html#t:options/0"},{"type":"type","title":"ExOwm.request/0","doc":"Current weather data API request.","ref":"ExOwm.html#t:request/0"},{"type":"type","title":"ExOwm.requests/0","doc":"Current weather data API requests.","ref":"ExOwm.html#t:requests/0"},{"type":"module","title":"ExOwm.Api","doc":"This module contains functions for interacting with the OpenWeatherMap API.\nIt prepares request strings, makes API calls, and parses the responses.","ref":"ExOwm.Api.html"},{"type":"function","title":"ExOwm.Api.send_and_parse_request/3","doc":"Prepares a request string based on the given parameters, calls the OWM API,\nand parses the JSON response.","ref":"ExOwm.Api.html#send_and_parse_request/3"},{"type":"function","title":"Parameters - ExOwm.Api.send_and_parse_request/3","doc":"- `api_call_type` (atom): The type of API call (e.g., `:get_weather`, `:get_current_weather`).\n  - `location` (map): The location parameters (e.g., city, coordinates, zip code).\n  - `opts` (term): Optional parameters for the API call (e.g., type, mode, units, cnt, lang).","ref":"ExOwm.Api.html#send_and_parse_request/3-parameters"},{"type":"function","title":"Returns - ExOwm.Api.send_and_parse_request/3","doc":"- (map): The parsed JSON response.\n  - `{:error, term, term}`: An error tuple containing the error type and the response.","ref":"ExOwm.Api.html#send_and_parse_request/3-returns"},{"type":"module","title":"ExOwm.CurrentWeather.Coordinator","doc":"This module is a GenServer implementation created for handling concurrent\nworker task coordination.","ref":"ExOwm.CurrentWeather.Coordinator.html"},{"type":"function","title":"ExOwm.CurrentWeather.Coordinator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.CurrentWeather.Coordinator.html#child_spec/1"},{"type":"function","title":"ExOwm.CurrentWeather.Coordinator.get_weather/2","doc":"","ref":"ExOwm.CurrentWeather.Coordinator.html#get_weather/2"},{"type":"function","title":"ExOwm.CurrentWeather.Coordinator.init/1","doc":"","ref":"ExOwm.CurrentWeather.Coordinator.html#init/1"},{"type":"function","title":"ExOwm.CurrentWeather.Coordinator.start_link/1","doc":"","ref":"ExOwm.CurrentWeather.Coordinator.html#start_link/1"},{"type":"module","title":"ExOwm.CurrentWeather.Worker","doc":"Current Weather Worker task implementation.","ref":"ExOwm.CurrentWeather.Worker.html"},{"type":"function","title":"ExOwm.CurrentWeather.Worker.get_current_weather/2","doc":"Returns current weather for a specific location and given options.\nChecks whether request has been already cached, if not it sends the request to\nOWM API and caches it with specific TTL.","ref":"ExOwm.CurrentWeather.Worker.html#get_current_weather/2"},{"type":"module","title":"ExOwm.FiveDayForecast.Coordinator","doc":"This module is a GenServer implementation created for handling concurrent\nworker task coordination.","ref":"ExOwm.FiveDayForecast.Coordinator.html"},{"type":"function","title":"ExOwm.FiveDayForecast.Coordinator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.FiveDayForecast.Coordinator.html#child_spec/1"},{"type":"function","title":"ExOwm.FiveDayForecast.Coordinator.get_weather/2","doc":"","ref":"ExOwm.FiveDayForecast.Coordinator.html#get_weather/2"},{"type":"function","title":"ExOwm.FiveDayForecast.Coordinator.init/1","doc":"","ref":"ExOwm.FiveDayForecast.Coordinator.html#init/1"},{"type":"function","title":"ExOwm.FiveDayForecast.Coordinator.start_link/1","doc":"","ref":"ExOwm.FiveDayForecast.Coordinator.html#start_link/1"},{"type":"module","title":"ExOwm.FiveDayForecast.Worker","doc":"Five Day Forecast Worker task implementation.","ref":"ExOwm.FiveDayForecast.Worker.html"},{"type":"function","title":"ExOwm.FiveDayForecast.Worker.get_five_day_forecast/2","doc":"Returns five day weather forecast for a specific location and given options.\nChecks whether request has been already cached, if not it sends the request to\nOWM API and caches it with specific TTL.","ref":"ExOwm.FiveDayForecast.Worker.html#get_five_day_forecast/2"},{"type":"module","title":"ExOwm.HistoricalWeather.Coordinator","doc":"This module is a GenServer implementation created for handling concurrent\nworker task coordination.","ref":"ExOwm.HistoricalWeather.Coordinator.html"},{"type":"function","title":"ExOwm.HistoricalWeather.Coordinator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.HistoricalWeather.Coordinator.html#child_spec/1"},{"type":"function","title":"ExOwm.HistoricalWeather.Coordinator.get_weather/2","doc":"","ref":"ExOwm.HistoricalWeather.Coordinator.html#get_weather/2"},{"type":"function","title":"ExOwm.HistoricalWeather.Coordinator.init/1","doc":"","ref":"ExOwm.HistoricalWeather.Coordinator.html#init/1"},{"type":"function","title":"ExOwm.HistoricalWeather.Coordinator.start_link/1","doc":"","ref":"ExOwm.HistoricalWeather.Coordinator.html#start_link/1"},{"type":"module","title":"ExOwm.HistoricalWeather.Worker","doc":"Five Day Forecast Worker task implementation.","ref":"ExOwm.HistoricalWeather.Worker.html"},{"type":"function","title":"ExOwm.HistoricalWeather.Worker.get_historical_weather/2","doc":"Returns five day weather forecast for a specific location and given options.\nChecks whether request has been already cached, if not it sends the request to\nOWM API and caches it with specific TTL.","ref":"ExOwm.HistoricalWeather.Worker.html#get_historical_weather/2"},{"type":"module","title":"ExOwm.HourlyForecast.Coordinator","doc":"This module is a GenServer implementation created for handling concurrent\nworker task coordination.","ref":"ExOwm.HourlyForecast.Coordinator.html"},{"type":"function","title":"ExOwm.HourlyForecast.Coordinator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.HourlyForecast.Coordinator.html#child_spec/1"},{"type":"function","title":"ExOwm.HourlyForecast.Coordinator.get_weather/2","doc":"","ref":"ExOwm.HourlyForecast.Coordinator.html#get_weather/2"},{"type":"function","title":"ExOwm.HourlyForecast.Coordinator.init/1","doc":"","ref":"ExOwm.HourlyForecast.Coordinator.html#init/1"},{"type":"function","title":"ExOwm.HourlyForecast.Coordinator.start_link/1","doc":"","ref":"ExOwm.HourlyForecast.Coordinator.html#start_link/1"},{"type":"module","title":"ExOwm.HourlyForecast.Worker","doc":"Five Day Forecast Worker task implementation.","ref":"ExOwm.HourlyForecast.Worker.html"},{"type":"function","title":"ExOwm.HourlyForecast.Worker.get_hourly_forecast/2","doc":"Returns five day weather forecast for a specific location and given options.\nChecks whether request has been already cached, if not it sends the request to\nOWM API and caches it with specific TTL.","ref":"ExOwm.HourlyForecast.Worker.html#get_hourly_forecast/2"},{"type":"module","title":"ExOwm.RequestString","doc":"Module responsible for creating request strings for OpenWeatherMap API calls.\nIt supports various API endpoints and allows for dynamic construction\nof query strings based on provided parameters.","ref":"ExOwm.RequestString.html"},{"type":"function","title":"ExOwm.RequestString.build/3","doc":"Builds request string based on provided params.","ref":"ExOwm.RequestString.html#build/3"},{"type":"function","title":"Parameters - ExOwm.RequestString.build/3","doc":"- `api_call_type` (atom): The type of API call (e.g., `:get_weather`, `:get_current_weather`).\n  - `location` (map): The location parameters (e.g., city, coordinates, zip code).\n  - `opts` (keyword list): Optional parameters (e.g., type, mode, units, cnt, lang).","ref":"ExOwm.RequestString.html#build/3-parameters"},{"type":"function","title":"Returns - ExOwm.RequestString.build/3","doc":"- (String.t()): The constructed request string.","ref":"ExOwm.RequestString.html#build/3-returns"},{"type":"module","title":"ExOwm.SixteenDayForecast.Coordinator","doc":"This module is a GenServer implementation created for handling concurrent\nworker task coordination.","ref":"ExOwm.SixteenDayForecast.Coordinator.html"},{"type":"function","title":"ExOwm.SixteenDayForecast.Coordinator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.SixteenDayForecast.Coordinator.html#child_spec/1"},{"type":"function","title":"ExOwm.SixteenDayForecast.Coordinator.get_weather/2","doc":"","ref":"ExOwm.SixteenDayForecast.Coordinator.html#get_weather/2"},{"type":"function","title":"ExOwm.SixteenDayForecast.Coordinator.init/1","doc":"","ref":"ExOwm.SixteenDayForecast.Coordinator.html#init/1"},{"type":"function","title":"ExOwm.SixteenDayForecast.Coordinator.start_link/1","doc":"","ref":"ExOwm.SixteenDayForecast.Coordinator.html#start_link/1"},{"type":"module","title":"ExOwm.SixteenDayForecast.Worker","doc":"Sixteen Day Forecast Worker task implementation.","ref":"ExOwm.SixteenDayForecast.Worker.html"},{"type":"function","title":"ExOwm.SixteenDayForecast.Worker.get_sixteen_day_forecast/2","doc":"Returns sixteen day weather forecast for a specific location and given options.\nChecks whether request has been already cached, if not it sends the request to\nOWM API and caches it with specific TTL.","ref":"ExOwm.SixteenDayForecast.Worker.html#get_sixteen_day_forecast/2"},{"type":"module","title":"ExOwm.Supervisor","doc":"Standard Supervisor implementation. This supervisor oversees various Coordinator GenServers used for handling concurrent OpenWeatherMap API calls.","ref":"ExOwm.Supervisor.html"},{"type":"function","title":"ExOwm.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.Supervisor.html#child_spec/1"},{"type":"function","title":"ExOwm.Supervisor.init/1","doc":"","ref":"ExOwm.Supervisor.html#init/1"},{"type":"function","title":"ExOwm.Supervisor.start_link/1","doc":"","ref":"ExOwm.Supervisor.html#start_link/1"},{"type":"module","title":"ExOwm.Weather.Coordinator","doc":"This module is a GenServer implementation created for handling concurrent\nworker task coordination.","ref":"ExOwm.Weather.Coordinator.html"},{"type":"function","title":"ExOwm.Weather.Coordinator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOwm.Weather.Coordinator.html#child_spec/1"},{"type":"function","title":"ExOwm.Weather.Coordinator.get_weather/2","doc":"","ref":"ExOwm.Weather.Coordinator.html#get_weather/2"},{"type":"function","title":"ExOwm.Weather.Coordinator.init/1","doc":"","ref":"ExOwm.Weather.Coordinator.html#init/1"},{"type":"function","title":"ExOwm.Weather.Coordinator.start_link/1","doc":"","ref":"ExOwm.Weather.Coordinator.html#start_link/1"},{"type":"module","title":"ExOwm.Weather.Worker","doc":"Current Weather Worker task implementation.","ref":"ExOwm.Weather.Worker.html"},{"type":"function","title":"ExOwm.Weather.Worker.get_weather/2","doc":"Returns current weather for a specific location and given options.\nChecks whether request has been already cached, if not it sends the request to\nOWM API and caches it with specific TTL.","ref":"ExOwm.Weather.Worker.html#get_weather/2"},{"type":"extras","title":"ExOwm","doc":"# ExOwm\n\n[![Hex Version](https://img.shields.io/hexpm/v/ex_owm.svg)](https://hex.pm/packages/ex_owm)\n[![Hex Docs](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/ex_owm/)\n[![License](https://img.shields.io/hexpm/l/ex_owm.svg)](https://github.com/kociamber/ex_owm/blob/master/LICENSE)\n[![Total Download](https://img.shields.io/hexpm/dt/ex_owm.svg)](https://hex.pm/packages/ex_owm)\n[![Last Updated](https://img.shields.io/github/last-commit/kociamber/ex_owm.svg)](https://github.com/kociamber/ex_owm/commits/master)\n\n**Fast [Open Weather Map](http://openweathermap.org/technology) API client for Elixir applications.**","ref":"readme.html"},{"type":"extras","title":"Installation - ExOwm","doc":"Add ExOwm as a dependency to your `mix.exs` file:\n\n```elixir\ndefp deps() do\n  [\n    {:ex_owm, \"~> 1.3.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Upgrade from 1.0.X - ExOwm","doc":"**Please re-factor** your configuration as the module naming (specifically the order) has slightly changed. Use the configuration below:","ref":"readme.html#upgrade-from-1-0-x"},{"type":"extras","title":"Configuration - ExOwm","doc":"To use OWM APIs, you need to [register](https://home.openweathermap.org/users/sign_up) for an account (free plan is available) and obtain an API key. After obtaining the key, set the environment variable OWM_API_KEY to your API key.\n\nIf you are using this application as a dependency in your project, add the following configuration to your `config/config.exs` file:\n\n```elixir\nconfig :ex_owm, api_key: System.get_env(\"OWM_API_KEY\")\n```\n\n..and you are ready to go!","ref":"readme.html#configuration"},{"type":"extras","title":"Basic Usage - ExOwm","doc":"ExOwm currently handles the following main OpenWeatherMap [APIs](http://openweathermap.org/api):\n\n*   [Current weather data](http://openweathermap.org/current)\n*   [One Call API](https://openweathermap.org/api/one-call-api)\n*   [One Call API History](https://openweathermap.org/api/one-call-api#history)\n*   [5 day / 3 hour forecast](http://openweathermap.org/forecast5)\n*   [1 - 16 day / daily forecast](http://openweathermap.org/forecast16)\n\nPlease note that with a standard (free) license/API key, you may be limited in the number of requests per minute and may not have access to the 1 - 16 day/daily forecast. Please refer to OpenWeatherMap [pricing plans](http://openweathermap.org/price) for more details..\n\nThere are three main public interface functions for each API, accepting the same set of two parameters: a list of location maps and a keyword list of options.\n\nSample API calls:\n\n```elixir\nExOwm.get_current_weather([%{city: \"Warsaw\"}, %{city: \"London\", country_code: \"uk\"}], units: :metric, lang: :pl)\n[{:ok, %{WARSAW_DATA}}, {:ok, %{LONDON_DATA}}]\n\nExOwm.get_five_day_forecast([%{city: \"Warsaw\"}, %{city: \"London\", country_code: \"uk\"}], units: :metric, lang: :pl)\n[{:ok, %{WARSAW_DATA}}, {:ok, %{LONDON_DATA}}]\n\nExOwm.get_sixteen_day_forecast([%{city: \"Warsaw\"}, %{city: \"unknown City Name\", country_code: \"uk\"}], units: :metric, lang: :pl, cnt: 16)\n[{:ok, %{WARSAW_DATA}}, {:error, :not_found, %{\"cod\" => \"404\", \"message\" => \"city not found\"}}]\n\nyesterday = DateTime.utc_now() |> DateTime.add(24 * 60 * 60 * -1, :second) |> DateTime.to_unix()\nExOwm.get_historical_weather([%{lat: 52.374031, lon: 4.88969, dt: yesterday}])\n[{:ok, %{CITY_DATA}}]\n\n```\n\nFor more details, refer to the official [docs](https://hexdocs.pm/ex_owm/readme.html).","ref":"readme.html#basic-usage"},{"type":"extras","title":"Overview - ExOwm","doc":"ExOwm utilizes some cool features such as:\n\n*   concurrent API calls\n*   super fast generational caching\n*   access to **main** [OWM APIs](http://openweathermap.org/api)!\n\nEach location entry in the list spawns a separate task (Elixir worker process) to check whether the request has been made within a specified time interval. If it has, the result is fetched from the cache. Otherwise, an API query is sent, the result is cached, and the data is returned.","ref":"readme.html#overview"},{"type":"extras","title":"Running local tests - ExOwm","doc":"Since all the tests are based on OWM API calls, they are disabled by default. To enable them, please remove `:api_based_test` from the `test/test_helper.exs file`.","ref":"readme.html#running-local-tests"},{"type":"extras","title":"To do - ExOwm","doc":"*   Add remaining OWM APIs (including One Call API 3.0)","ref":"readme.html#to-do"},{"type":"extras","title":"License - ExOwm","doc":"This project is MIT licensed. Please see the [`LICENSE.md`](https://github.com/Kociamber/ex_owm/blob/master/LICENSE.md) file for more details.","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}